package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.ui.Mouse;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		
		private var cur:Number;
		private var rot:Number;
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		Mouse.hide();
		private function setup():void
		{
			max			= 800;
			fibonacci	= 1/1.618033989;
			accident	= .998;
			rapport 	= 90-360*fibonacci - 1;
			rad 		= 300;
			growth		= 1.004;
			sc_x		= 120;
			sc_y		= 70;
			rpx			= 1.001;
			rpy			= 1.018;
		
			cur			= max;
			rot			= 0;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
			removeEventListener(Event.ENTER_FRAME,enterhandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			graphics.clear();
			setup();
			addEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		private function enterhandler(e:Event):void
		{
			if(cur)
			{
				cur++;
				//rapport*=accident;
				//sc_x*=rpx;
				//sc_y*=rpy;
				rot -= rapport;
				//rot-= new int(rot/360)*360;
				//rad*=growth;
				var x:Number = mouseY+Math.cos(rot * Math.PI/1) *rad;
				var y:Number = mouseX+Math.sin(rot * Math.PI/1) *rad;
				if(cur!= (max-1)){
					graphics.lineStyle(1,0xeeeeee,.1);
					graphics.lineTo(y,x);
				}else{
					graphics.moveTo(y,x);
				}
			}else{
				removeEventListener(Event.ENTER_FRAME,enterhandler);
			}
		}
		
	}
}